Use this API to manage issue boards and their lists, for both projects and groups.

Every call to this API requires authentication. If the project or group is private and the authenticated user is not a member, a GET request results in a 404 status code.

List all group issue boards in a group

GET /api/v4/groups/{id}/boards

Lists all group issue boards for a specified group.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
page
Query
IntegerCurrent page number
Default: 1
Example: 1
per_page
Query
IntegerNumber of items per page
Default: 20
Example: 20

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

Retrieve a group issue board

GET /api/v4/groups/{id}/boards/{board_id}

Retrieves a specified group issue board.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

Update a group issue board

PUT /api/v4/groups/{id}/boards/{board_id}

Updates a specified group issue board.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board

Request body (application/json)

PropertyTypeDescription
hide_backlog_listBooleanHide the Open list
hide_closed_listBooleanHide the Closed list
nameStringThe board name

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

List all group issue board lists

GET /api/v4/groups/{id}/boards/{board_id}/lists

Lists all group issue board lists for a specified board. Does not include open and closed lists.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board
page
Query
IntegerCurrent page number
Default: 1
Example: 1
per_page
Query
IntegerNumber of items per page
Default: 20
Example: 20

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Create a group issue board list

POST /api/v4/groups/{id}/boards/{board_id}/lists

Creates a group issue board list for a specified board.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board

Request body (application/json)

PropertyTypeDescription
label_id
Required
IntegerThe ID of an existing label

Responses

CodeDescriptionSchema
201CreatedAPIEntitiesList
400Bad Request—
404Not Found—

Retrieve a group issue board list

GET /api/v4/groups/{id}/boards/{board_id}/lists/{list_id}

Retrieves a specified group issue board list.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board
list_id
Path, required
IntegerThe ID of a list

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Update a group issue board list

PUT /api/v4/groups/{id}/boards/{board_id}/lists/{list_id}

Updates a specified group issue board list. This call is used to change list position.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board
list_id
Path, required
IntegerThe ID of a list

Request body (application/json)

PropertyTypeDescription
position
Required
IntegerThe position of the list

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Delete a group issue board list

DELETE /api/v4/groups/{id}/boards/{board_id}/lists/{list_id}

Deletes a specified group issue board list. Only for administrators and users with the Owner role for the group.

Parameters

NameTypeDescription
id
Path, required
StringThe ID of a group
board_id
Path, required
IntegerThe ID of a board
list_id
Path, required
IntegerThe ID of a board list

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

List all project issue boards

GET /api/v4/projects/{id}/boards

Lists all issue boards in a specified project.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
page
Query
IntegerCurrent page number
Default: 1
Example: 1
per_page
Query
IntegerNumber of items per page
Default: 20
Example: 20

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

Create an issue board

POST /api/v4/projects/{id}/boards

Creates an issue board in a specified project.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project

Request body (application/json)

PropertyTypeDescription
name
Required
StringThe board name

Responses

CodeDescriptionSchema
201CreatedAPIEntitiesBoard
400Bad Request—
404Not Found—

Retrieve an issue board

GET /api/v4/projects/{id}/boards/{board_id}

Retrieves a specified issue board in a project.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

Update an issue board

PUT /api/v4/projects/{id}/boards/{board_id}

Updates a specified issue board in a project.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board

Request body (application/json)

PropertyTypeDescription
hide_backlog_listBooleanHide the Open list
hide_closed_listBooleanHide the Closed list
nameStringThe board name

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

Delete an issue board

DELETE /api/v4/projects/{id}/boards/{board_id}

Deletes a specified issue board in a project.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board

Responses

CodeDescriptionSchema
200OKAPIEntitiesBoard
400Bad Request—
404Not Found—

List all board lists in an issue board

GET /api/v4/projects/{id}/boards/{board_id}/lists

Lists all lists in a specified issue board. Does not include open and closed lists.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board
page
Query
IntegerCurrent page number
Default: 1
Example: 1
per_page
Query
IntegerNumber of items per page
Default: 20
Example: 20

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Create an issue board list

POST /api/v4/projects/{id}/boards/{board_id}/lists

Creates an issue board list.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board

Request body (application/json)

PropertyTypeDescription
label_id
Required
IntegerThe ID of an existing label

Responses

CodeDescriptionSchema
201CreatedAPIEntitiesList
400Bad Request—
404Not Found—

Retrieve a board list

GET /api/v4/projects/{id}/boards/{board_id}/lists/{list_id}

Retrieves a specified list from an issue board.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board
list_id
Path, required
IntegerThe ID of a list

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Update position of a board list

PUT /api/v4/projects/{id}/boards/{board_id}/lists/{list_id}

Updates the position of a specified list from an issue board.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board
list_id
Path, required
IntegerThe ID of a list

Request body (application/json)

PropertyTypeDescription
position
Required
IntegerThe position of the list

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Delete a list from an issue board

DELETE /api/v4/projects/{id}/boards/{board_id}/lists/{list_id}

Deletes a specified list from an issue board.

Parameters

NameTypeDescription
id
Path, required
String or integerThe ID or URL-encoded path of the project
board_id
Path, required
IntegerThe ID of a board
list_id
Path, required
IntegerThe ID of a board list

Responses

CodeDescriptionSchema
200OKAPIEntitiesList
400Bad Request—
404Not Found—

Schemas

Objects returned by the operations above and objects nested in their request bodies.

APIEntitiesBasicProjectDetails

PropertyTypeDescription
avatar_urlStringExample: http://example.com/uploads/project/avatar/3/uploads/avatar.png
created_atString (date-time)Example: 2020-05-07T04:27:17.016Z
custom_attributesAPIEntitiesCustomAttribute—
default_branchStringExample: main
descriptionStringExample: desc
forks_countIntegerExample: 1
http_url_to_repoStringExample: https://gitlab.example.com/gitlab/gitlab.git
idInteger (int64)Example: 1
last_activity_atString (date-time)Example: 2013-09-30T13:46:02Z
licenseAPIEntitiesLicenseBasic—
license_urlStringExample: https://gitlab.example.com/gitlab/gitlab/blob/master/LICENCE
nameStringExample: project1
name_with_namespaceStringExample: John Doe / project1
namespaceAPIEntitiesNamespaceBasic—
pathStringExample: project1
path_with_namespaceStringExample: namespace1/project1
readme_urlStringExample: https://gitlab.example.com/gitlab/gitlab/blob/master/README.md
repository_storageStringExample: default
ssh_url_to_repoStringExample: git@gitlab.example.com:gitlab/gitlab.git
star_countIntegerExample: 1
tag_listArray of stringsExample: ["tag"]
topicsArray of stringsExample: ["topic"]
visibilityStringExample: public
web_urlStringExample: https://gitlab.example.com/gitlab/gitlab

APIEntitiesBoard

PropertyTypeDescription
hide_backlog_listBooleanExample: false
hide_closed_listBooleanExample: false
idInteger (int64)Example: 1
listsArray of APIEntitiesList—
nameStringExample: Development
projectAPIEntitiesBasicProjectDetails—

APIEntitiesCustomAttribute

PropertyTypeDescription
keyStringExample: foo
valueStringExample: bar

APIEntitiesLabelBasic

PropertyTypeDescription
archivedBooleanExample: false
colorStringExample: #FF0000
descriptionStringExample: Bug reported by user
description_htmlStringExample: <p>Bug reported by user</p>
idInteger (int64)Example: 1
nameStringExample: bug
text_colorStringExample: #FFFFFF

APIEntitiesLicenseBasic

PropertyTypeDescription
html_urlStringExample: http://choosealicense.com/licenses/gpl-3.0
keyStringExample: gpl-3.0
nameStringExample: GNU General Public License v3.0
nicknameStringExample: GNU GPLv3
source_urlString—

APIEntitiesList

PropertyTypeDescription
idInteger (int64)Example: 1
labelAPIEntitiesLabelBasic—
positionIntegerExample: 1

APIEntitiesNamespaceBasic

PropertyTypeDescription
avatar_urlStringExample: https://example.com/avatar/12345
full_pathStringExample: group/my_project
idInteger (int64)Example: 2
kindStringExample: project
nameStringExample: project
parent_idInteger (int64)Example: 1
pathStringExample: my_project
web_urlStringExample: https://example.com/group/my_project